/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;
import javax.swing.tree.*;

public class JMCAD extends JFrame {
  public static boolean isSingle = false;
  private String VERSION = "JMCAD v 07.085 http://jmcad.sf.net";
  private int openFrameCount = 0;
  private int xOffset = 30, yOffset = 30;
  ImageIcon img_new = new ImageIcon(JMCAD.class.getResource("new.gif"));
  ImageIcon img_open = new ImageIcon(JMCAD.class.getResource("open.gif"));
  ImageIcon img_save = new ImageIcon(JMCAD.class.getResource("save.gif"));
  ImageIcon img_config = new ImageIcon(JMCAD.class.getResource("config.gif"));
  ImageIcon img_run = new ImageIcon(JMCAD.class.getResource("run.gif"));
  ImageIcon img_stop = new ImageIcon(JMCAD.class.getResource("stop.gif"));
  ImageIcon img_debug = new ImageIcon(JMCAD.class.getResource("debug.gif"));
  ImageIcon img_visual = new ImageIcon(JMCAD.class.getResource("visual.gif"));
  ImageIcon img_help = new ImageIcon(JMCAD.class.getResource("help.png"));
  ImageIcon img_about = new ImageIcon(JMCAD.class.getResource("about.png"));
  ImageIcon img_select = new ImageIcon(JMCAD.class.getResource("select.gif"));
  ImageIcon img_erase = new ImageIcon(JMCAD.class.getResource("erase.gif"));
  private JFrame w_help;
  private JTextPane TextPane;
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu Menu_File = new JMenu(ResourceBundle.getBundle("JMCAD_Internationalize").getString("File"));
  private JMenu Menu_Elements = new JMenu(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Elements"));
  private JMenu Menu_Run = new JMenu(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Run"));
  private JMenu Menu_Window = new JMenu(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Window"));
  private JMenu Menu_Help = new JMenu(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Help"));
  private JMenuItem mnu_new = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("New"));
  private JMenuItem mnu_open = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open"));
  private JMenuItem mnu_save = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save"));
  private JMenuItem mnu_saveas = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save_as"));
  private JMenuItem mnu_quit = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Quit"));
  private JMenuItem mnu_about = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("About"));
  private JMenuItem mnu_help = new JMenuItem(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Help"));
  private JToolBar TB = new JToolBar();
  private JButton b_new = new JButton();
  private JButton b_erase = new JButton();
  private JButton b_open = new JButton();
  private JButton b_save = new JButton();
  public JToggleButton b_select = new JToggleButton();
  private JButton b_config = new JButton();
  private JButton b_about = new JButton();
  private JButton b_help = new JButton();
  public JToggleButton b_start = new JToggleButton();
  public JToggleButton b_debug = new JToggleButton();
  public JButton b_visual = new JButton();
  private JSplitPane split_pane = new JSplitPane();
  //private JSplitPane split_pane_l = new JSplitPane();
  //private ButtonGroup btgroup = new ButtonGroup();
  public JButton b_elements = new JButton(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Elements"));
  public JButton b_files = new JButton(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Files"));
  private JPanel tools_pane = new JPanel(new BorderLayout());
  private JPanel tools_pane_top = new JPanel(new GridLayout(1,2));
  private JPanel tools_pane_center = new JPanel(new CardLayout());
  private JScrollPane sp_list = new JScrollPane();
  private JScrollPane sp_tree_menu = new JScrollPane();
  private JDesktopPane desktop = new JDesktopPane();
  private JList list = new JList();
  private DefaultMutableTreeNode root_node_tree_menu = new DefaultMutableTreeNode("Root Node");
  private DefaultTreeModel model_tree_menu = new DefaultTreeModel(root_node_tree_menu);
  public JTree tree_menu = new JTree(model_tree_menu);
  private JMCADDocument doc_visual;

  public JMCAD() {
    try {
      if(isSingle) NewMainFrame(); else {
          System.out.println(VERSION);
          System.out.println("Default Localization: "+Locale.getDefault());
          new JMCADNewVersionInfo(VERSION).start();
          jbInit();
      }
    }catch(Exception e) { e.printStackTrace(); }
  }
  public static void main(String[] args) {
    try {
        UIManager.put("swing.boldMetal", Boolean.FALSE);
        JDialog.setDefaultLookAndFeelDecorated(true);
        JFrame.setDefaultLookAndFeelDecorated(true);
        Toolkit.getDefaultToolkit().setDynamicLayout(true);
        System.setProperty("sun.awt.noerasebackground","true");
        UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
    }catch(Exception e) { e.printStackTrace(); }
    if(args.length>=2){
        if(args[0].equalsIgnoreCase("-single")){
            isSingle = true;
            JMCAD jmcad = new JMCAD();
            jmcad.Open_Document(args[1]);
            jmcad.setVisible(true);
            jmcad.validateTree();
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            jmcad.setLocation((screenSize.width-jmcad.getWidth())/2,(screenSize.height-jmcad.getHeight())/2);
        }else new JMCAD();
    }else new JMCAD();
  }

  private void jbInit() throws Exception {
    this.setTitle(VERSION);
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    this.setJMenuBar(jMenuBar1);
    setBounds(50,50,screenSize.width-100, screenSize.height-100);
    setExtendedState(JFrame.MAXIMIZED_BOTH);
    //GraphicsEnvironment environment = GraphicsEnvironment.getLocalGraphicsEnvironment();
    //GraphicsDevice device = environment.getDefaultScreenDevice();
    //setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    //setUndecorated(true);
    ///setIgnoreRepaint(true);
    //setResizable(false);
    //device.setFullScreenWindow(this);
    this.getContentPane().setLayout(new BorderLayout());
    this.setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        exit();
      }
    });
    tree_menu.addTreeSelectionListener(new TreeSelectionListener() {
        public void valueChanged(TreeSelectionEvent e) {
            DefaultMutableTreeNode nd = (DefaultMutableTreeNode) tree_menu.getLastSelectedPathComponent();
            if(nd!=null)try{
                if(nd.getUserObject() instanceof JToggleButton){
                    Add_Object((JMCADObject)Class.forName(((JToggleButton)nd.getUserObject()).getActionCommand()).newInstance());
                    b_select.setSelected(false);
                }
            }catch(Exception e2) { System.out.println(e2); }
        }
    });
    jMenuBar1.add(Menu_File);
    jMenuBar1.add(Menu_Elements);
    jMenuBar1.add(Menu_Run);
    jMenuBar1.add(Menu_Window);
    jMenuBar1.add(Menu_Help);
    Menu_File.add(mnu_new);
    Menu_File.add(mnu_open);
    Menu_File.addSeparator();
    Menu_File.add(mnu_save);
    Menu_File.add(mnu_saveas);
    Menu_File.addSeparator();
    Menu_File.add(mnu_quit);
    Menu_Help.add(mnu_about);
    Menu_Help.add(mnu_help);
    mnu_new.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        NewFrame();
      }
    });
    mnu_open.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_open_document();
      }
    });
    mnu_save.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_save_actionPerformed(e);
      }
    });
    mnu_saveas.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_saveas_actionPerformed(e);
      }
    });
    mnu_quit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        exit();
      }
    });
    mnu_about.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        about();
      }
    });
    mnu_help.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_help_actionPerformed(e);
      }
    });
    b_new.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        NewFrame();
      }
    });
    b_new.setIcon(img_new);
    b_new.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("New"));
    b_open.setIcon(img_open);
    b_open.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open"));
    b_open.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_open_document();
      }
    });
    b_save.setIcon(img_save);
    b_save.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save"));
    b_save.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_save_actionPerformed(e);
      }
    });
    b_select.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Select_object"));
    b_select.setIcon(img_select);
    b_select.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Add_Object(null);        
        if(desktop.getSelectedFrame()==null || tree_menu.getSelectionCount()==0)b_select.setSelected(true);
        tree_menu.clearSelection();
      }
    });
    b_config.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Configuring_model"));
    b_config.setIcon(img_config);
    b_config.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_config_actionPerformed(e);
      }
    });
    b_help.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Help"));
    b_help.setIcon(img_help);
    b_help.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_help_actionPerformed(e);
      }
    });
    b_about.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("About"));
    b_about.setIcon(img_about);
    b_about.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        about();
      }
    });
    b_start.setIcon(img_run);
    b_start.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Run"));
    b_start.setSelectedIcon(img_stop);
    b_start.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          if(desktop.getSelectedFrame()==null)b_start.setSelected(false);
          ((JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0)).Document_Calc();
          b_start.setSelected(((JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0)).Document_isCalc());
        }catch(Exception e1) {}
      }
    });
    b_debug.setIcon(img_debug);
    b_debug.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Debug")+". "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("It_is_set_in_model_parametres"));
    b_debug.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try{
          if(desktop.getSelectedFrame()==null)b_debug.setSelected(false);
          ((JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0)).Document_setDebug(b_debug.isSelected());
          b_debug.setSelected(((JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0)).Document_isDebug());
        }catch(Exception e1) {}
      }
    });
    b_visual.setIcon(img_visual);
    b_visual.setToolTipText(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("GUI_for_control_and_display_data"));
    b_visual.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_visual_actionPerformed(e);
      }
    });
    b_erase.setToolTipText(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Deleting_of_the_selected_objects"));
    b_erase.setIcon(img_erase);
    b_erase.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        b_erase_actionPerformed(e);
      }
    });
    b_elements.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ((CardLayout)tools_pane_center.getLayout()).show(tools_pane_center, "Elements");
        b_files.setBackground(SystemColor.controlHighlight);
        b_elements.setBackground(Color.WHITE);
      }
    });
    b_files.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        ((CardLayout)tools_pane_center.getLayout()).show(tools_pane_center, "Files");
        b_elements.setBackground(SystemColor.controlHighlight);
        b_files.setBackground(Color.WHITE);
      }
    });
    split_pane.setOneTouchExpandable(true);
    this.getContentPane().add(TB, BorderLayout.NORTH);
    this.getContentPane().add(split_pane, BorderLayout.CENTER);
    split_pane.add(desktop, JSplitPane.BOTTOM);
    split_pane.add(tools_pane, JSplitPane.TOP);
    tools_pane.add(tools_pane_top, BorderLayout.NORTH);
    tools_pane.add(tools_pane_center, BorderLayout.CENTER);
    b_elements.setBackground(Color.WHITE);
    b_elements.setMargin(new Insets(0, 0, 0, 0));
    b_elements.setFocusPainted(false);
    b_elements.setFocusable(false);
    b_files.setBackground(SystemColor.controlHighlight);
    b_files.setMargin(new Insets(0, 0, 0, 0));
    b_files.setFocusPainted(false);
    b_files.setFocusable(false);
    tools_pane_top.add(b_elements);
    tools_pane_top.add(b_files);
    tools_pane_center.add(sp_tree_menu, "Elements");
    tools_pane_center.add(sp_list, "Files");
    tree_menu.setRootVisible(false);
    tree_menu.setShowsRootHandles(true);
    tree_menu.putClientProperty("JTree.lineStyle", "Horizontal");
    sp_tree_menu.getViewport().add(tree_menu, null);
    list.setMinimumSize(new Dimension(0,0));
    sp_list.getViewport().add(list, null);
    list.addMouseListener(new java.awt.event.MouseAdapter() {
        public void mouseClicked(java.awt.event.MouseEvent evt) {
            if(evt.getClickCount()==2){
            try{
                JList l = (JList)evt.getSource();
                Open_Document((((DefaultListModel)l.getModel()).elementAt(l.getSelectedIndex()))+".jmcad");
            }catch(Exception e1){}
        }
        }
    });
    TB.add(b_new);
    TB.add(b_open, null);
    TB.add(b_save, null);
    TB.addSeparator();
    TB.add(b_config, null);
    TB.add(b_start, null);
    TB.add(b_debug, null);
    TB.addSeparator();
    TB.add(b_visual, null);
    TB.addSeparator();
    TB.add(b_select, null);
    TB.add(b_erase, null);
    TB.addSeparator();
    TB.add(b_about, null);
    TB.add(b_help, null);
    this.setVisible(true);
    Load_Menu();
    split_pane.setDividerLocation(200);
    this.setFocusable(true);
    /*
    JComponent c = (JComponent) getContentPane();
    InputMap inputMap = c.getInputMap(JComponent.WHEN_FOCUSED);
    inputMap.put(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE, 0), "alph" + KeyEvent.VK_DELETE);
    c.getActionMap().put("alph" + KeyEvent.VK_DELETE, b_erase.getAction());
    this.setFocusable(true);
    */
  }
  protected void NewMainFrame() {
    this.setTitle(VERSION);
    this.setResizable(false);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
  }
  protected void NewFrame() {
    if(xOffset+200>getWidth()){
      xOffset=30;
    }
    if(yOffset+200>getHeight()){
      yOffset=30;
    }
    JInternalFrame frame = new JInternalFrame(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Model")+" #" + (++openFrameCount), true, true, true, true);
    frame.setLocation(xOffset, yOffset);
    frame.setSize(550,400);
    frame.setVisible(true);
    frame.getContentPane().setLayout(new BorderLayout());
    frame.getContentPane().add(new JMCADDocument(), BorderLayout.CENTER);
    desktop.add(frame);
    try {
      frame.setSelected(true);
      b_start.setSelected(false);
      b_debug.setSelected(false);
      b_select.doClick();
      b_select.setSelected(true);
    } catch (Exception e) {}
    frame.addInternalFrameListener(new InternalFrameAdapter(){
      public void internalFrameActivated(InternalFrameEvent e){
        JMCADDocument doc = (JMCADDocument)e.getInternalFrame().getContentPane().getComponent(0);
        b_start.setSelected(doc.Document_isCalc());
        b_debug.setSelected(doc.Document_isDebug());
        b_select.doClick();
        b_select.setSelected(true);
      }
      public void internalFrameOpened(InternalFrameEvent e){
        JMCADDocument doc = (JMCADDocument)e.getInternalFrame().getContentPane().getComponent(0);
        b_start.setSelected(doc.Document_isCalc());
        b_debug.setSelected(doc.Document_isDebug());
        b_select.doClick();
        b_select.setSelected(true);
      }
      public void internalFrameClosing(InternalFrameEvent e){
        e.getInternalFrame().setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
        int res = JOptionPane.showInternalConfirmDialog(desktop,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save")+": "+e.getInternalFrame().getTitle(),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save"),JOptionPane.YES_NO_CANCEL_OPTION);
        if(res==0)b_save_actionPerformed(null);
        if(res!=2){
            e.getInternalFrame().setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
            b_start.setSelected(false);
            JMCADDocument doc = (JMCADDocument)e.getInternalFrame().getContentPane().getComponent(0);
            doc.Document_Calc_Stop();
        }
        b_select.doClick();
        b_select.setSelected(true);
      }
    });
    xOffset+=30;
    yOffset+=30;
  }

  public void Add_Object(JMCADObject obj){
    try{
      ((JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0)).Document_Add_Object(obj);
    }catch(Exception e) {  }
  }

  private void Load_Menu(){
    try{
      RandomAccessFile fin = new RandomAccessFile("JMCAD.menu","r");
      String st;
      JMenu mnu = null;
      DefaultTreeCellRenderer node_renderer = new DefaultTreeCellRenderer(){
          public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus) {
            super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
            DefaultMutableTreeNode nd = (DefaultMutableTreeNode)value;
            if(nd.getUserObject() instanceof JToggleButton){
                setIcon(((JToggleButton)nd.getUserObject()).getIcon());
                setToolTipText(((JToggleButton)nd.getUserObject()).getToolTipText());
            }else setIcon(null);
            return this;
          }
      };
      node_renderer.setLeafIcon(null);
      node_renderer.setClosedIcon(null);
      node_renderer.setOpenIcon(null);
      node_renderer.setBackground(new JPanel().getBackground());
      tree_menu.setCellRenderer(node_renderer);
      DefaultMutableTreeNode treeNode = null;
      while((st=fin.readLine())!=null){
        try{
          st = st.trim();
          if(st.startsWith("#")) continue;
          if(st.length()!=0){
            if(st.startsWith("[") && st.endsWith("]")){
              String st_mnu = st.substring(1,st.length()-1);
              try{
                st_mnu = ResourceBundle.getBundle("JMCAD_Internationalize").getString(st_mnu.trim().replace(' ', '_'));
              }catch(Exception ei) { System.out.println(ei); }
              mnu = new JMenu(st_mnu);
              Menu_Elements.add(mnu);
              treeNode = new DefaultMutableTreeNode(st_mnu);
              root_node_tree_menu.add(treeNode);
            }else{
              try{
              JToggleButton b = new JToggleButton(){
                  public String toString(){
                      return this.getToolTipText();
                  }
              };
              StringTokenizer stt = new StringTokenizer(st);
              String st_ActionCommand = stt.nextToken();
              b.setActionCommand(st_ActionCommand);
              b.setMargin(new Insets(0, 0, 0, 0));
              b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                  try{
                    Add_Object((JMCADObject)Class.forName(e.getActionCommand()).newInstance());
                  }catch(Exception e2) { System.out.println(e2); }
                }
              });
              ImageIcon img = new ImageIcon(JMCAD.class.getResource(stt.nextToken()));
              String st_ToolTipText = ((JMCADObject)Class.forName(b.getActionCommand()).newInstance()).ToolTipText;
              //ImageIcon img24x24 = new ImageIcon(img.getImage().getScaledInstance(24, 24, Image.SCALE_DEFAULT));
              b.setIcon(img);
              b.setToolTipText(st_ToolTipText);
              JMenuItem mnu_item = new JMenuItem(st_ToolTipText);
              mnu_item.setIcon(img);
              mnu_item.setActionCommand(st_ActionCommand);
              mnu_item.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                  try{
                    Add_Object((JMCADObject)Class.forName(e.getActionCommand()).newInstance());
                  }catch(Exception e2) { System.out.println(e2); }
                }
              });
              mnu.add(mnu_item);
              DefaultMutableTreeNode node = new DefaultMutableTreeNode(b);
              treeNode.add(node);
              }catch(Exception e2) { e2.printStackTrace(); }
            }
          }
        }catch(Exception e1) { e1.printStackTrace(); }
      }
      model_tree_menu.reload();
      fin.close();
      Load_List();
    }catch(Exception e) { System.out.println(e); }
  }
  public void Load_List(){
      try{
        File f = new File(".");
        String[] fst = f.list();
        DefaultListModel listModel = new DefaultListModel();
        for(int i=0; i<fst.length; i++){
            if(fst[i].indexOf(".jmcad")!=-1){
            listModel.addElement(fst[i].substring(0,fst[i].length()-6));
            }
        }
        list.setModel(listModel);
        list.doLayout();
      }catch(Exception e) { System.out.println(e); }
  }
  public void error(Object st){
    JOptionPane.showMessageDialog(this,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error:")+st,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error!"),JOptionPane.ERROR_MESSAGE);
    if(st instanceof Exception) ((Exception)st).printStackTrace(); else System.out.println(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error:")+st);
  }
  public void exit(){
    JInternalFrame[] jif = desktop.getAllFrames();
    try{
      for(int i=0; i<jif.length; i++) jif[i].doDefaultCloseAction();
    }catch(Exception e1) {}
    jif = desktop.getAllFrames();
    if(jif.length==0)System.exit(0);
  }
  void b_config_actionPerformed(ActionEvent e) {
    try{
      if(desktop.getSelectedFrame()==null)return;
      JMCADDocument doc = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
      doc.setConfig();
    }catch(Exception e1) { error(e1); }
  }

  void b_help_actionPerformed(ActionEvent e) {
    try{
      //Desktop.getDesktop().browse( new URI("http://jmcad.sf.net/"));
    }catch(Exception e1) { error(e1); }
    if(w_help==null) {
      w_help = new JFrame();
      w_help.getContentPane().setLayout(new BorderLayout());
      w_help.setTitle(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Help._The_menu_and_elements.")+" "+this.getTitle());
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      w_help.setBounds(100,100,screenSize.width-200, screenSize.height-200);
    }else w_help.getContentPane().removeAll();
    JScrollPane sp = new JScrollPane();
    try{
    //==========================================================================
    TextPane = new JTextPane();
    StyledDocument sdoc = TextPane.getStyledDocument();
    Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);
    Style s = sdoc.addStyle("txt_bold_grey", def);
    StyleConstants.setFontFamily(s, "SansSerif");
    StyleConstants.setBold(s, true);
    StyleConstants.setBackground(s, new Color(100,100,170,100));//Color.LIGHT_GRAY);
    s = sdoc.addStyle("txt_bold", def);
    StyleConstants.setFontFamily(s, "SansSerif");
    StyleConstants.setBold(s, true);
    s = sdoc.addStyle("txt_size8", s);
    StyleConstants.setFontFamily(s, "SansSerif");
    StyleConstants.setFontSize(s, 10);
    StyleConstants.setForeground(s, Color.BLUE);
    JButton bt_menu1 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Menu"));
    JButton bt_tool_bar1 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tool_Bar"));
    JButton bt_tabs1 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tabs"));
    JButton bt_info1 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Info"));
    bt_menu1.setBackground(Color.ORANGE);
    bt_menu1.setEnabled(false);
    bt_tool_bar1.setContentAreaFilled(false);
    bt_tabs1.setContentAreaFilled(false);
    bt_info1.setContentAreaFilled(false);
    bt_tool_bar1.setFocusPainted(false);
    bt_tabs1.setFocusPainted(false);
    bt_tool_bar1.setFocusable(false);
    bt_tabs1.setFocusable(false);
    bt_info1.setFocusable(false);
    bt_tool_bar1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand()));} catch (Exception t3) {}
      }
    });
    bt_tabs1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_info1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    s = sdoc.addStyle("bt_menu1", s);
    StyleConstants.setComponent(s, bt_menu1);
    s = sdoc.addStyle("bt_tool_bar1", s);
    StyleConstants.setComponent(s, bt_tool_bar1);
    s = sdoc.addStyle("bt_tabs1", s);
    StyleConstants.setComponent(s, bt_tabs1);
    s = sdoc.addStyle("bt_info1", s);
    StyleConstants.setComponent(s, bt_info1);
    JButton bt_menu2 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Menu"));
    JButton bt_tool_bar2 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tool_Bar"));
    JButton bt_tabs2 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tabs"));
    JButton bt_info2 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Info"));
    bt_tool_bar2.setBackground(Color.ORANGE);
    bt_tool_bar2.setEnabled(false);
    bt_menu2.setContentAreaFilled(false);
    bt_tabs2.setContentAreaFilled(false);
    bt_info2.setContentAreaFilled(false);
    bt_menu2.setFocusPainted(false);
    bt_tabs2.setFocusPainted(false);
    bt_menu2.setFocusable(false);
    bt_tabs2.setFocusable(false);
    bt_info2.setFocusable(false);
    bt_menu2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(1);} catch (Exception t3) {}
      }
    });
    bt_tabs2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_info2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    s = sdoc.addStyle("bt_menu2", s);
    StyleConstants.setComponent(s, bt_menu2);
    s = sdoc.addStyle("bt_tool_bar2", s);
    StyleConstants.setComponent(s, bt_tool_bar2);
    s = sdoc.addStyle("bt_tabs2", s);
    StyleConstants.setComponent(s, bt_tabs2);
    s = sdoc.addStyle("bt_info2", s);
    StyleConstants.setComponent(s, bt_info2);
    JButton bt_menu3 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Menu"));
    JButton bt_tool_bar3 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tool_Bar"));
    JButton bt_tabs3 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tabs"));
    JButton bt_info3 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Info"));
    bt_tabs3.setBackground(Color.ORANGE);
    bt_tabs3.setEnabled(false);
    bt_menu3.setContentAreaFilled(false);
    bt_info3.setContentAreaFilled(false);
    bt_tool_bar3.setContentAreaFilled(false);
    bt_menu3.setFocusPainted(false);
    bt_tabs3.setFocusPainted(false);
    bt_tool_bar3.setFocusPainted(false);
    bt_menu3.setFocusable(false);
    bt_tool_bar3.setFocusable(false);
    bt_info3.setFocusable(false);
    bt_menu3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(1);} catch (Exception t3) {}
      }
    });
    bt_tool_bar3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_info3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    s = sdoc.addStyle("bt_menu3", s);
    StyleConstants.setComponent(s, bt_menu3);
    s = sdoc.addStyle("bt_tool_bar3", s);
    StyleConstants.setComponent(s, bt_tool_bar3);
    s = sdoc.addStyle("bt_tabs3", s);
    StyleConstants.setComponent(s, bt_tabs3);
    s = sdoc.addStyle("bt_info3", s);
    StyleConstants.setComponent(s, bt_info3);
    JButton bt_menu4 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Menu"));
    JButton bt_tool_bar4 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tool_Bar"));
    JButton bt_tabs4 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tabs"));
    JButton bt_info4 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Info"));
    bt_info4.setBackground(Color.ORANGE);
    bt_info4.setEnabled(false);
    bt_menu4.setContentAreaFilled(false);
    bt_tabs4.setContentAreaFilled(false);
    bt_tool_bar4.setContentAreaFilled(false);
    bt_menu4.setFocusPainted(false);
    bt_tabs4.setFocusPainted(false);
    bt_tool_bar4.setFocusPainted(false);
    bt_menu4.setFocusable(false);
    bt_tabs4.setFocusable(false);
    bt_tool_bar4.setFocusable(false);
    bt_menu4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(1);} catch (Exception t3) {}
      }
    });
    bt_tabs4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_tool_bar4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    s = sdoc.addStyle("bt_menu4", s);
    StyleConstants.setComponent(s, bt_menu4);
    s = sdoc.addStyle("bt_tool_bar4", s);
    StyleConstants.setComponent(s, bt_tool_bar4);
    s = sdoc.addStyle("bt_tabs4", s);
    StyleConstants.setComponent(s, bt_tabs4);
    s = sdoc.addStyle("bt_info4", s);
    StyleConstants.setComponent(s, bt_info4);
    JButton bt_menu5 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Menu"));
    JButton bt_tool_bar5 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tool_Bar"));
    JButton bt_tabs5 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Tabs"));
    JButton bt_info5 = new JButton(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Info"));
    bt_tool_bar5.setContentAreaFilled(false);
    bt_menu5.setContentAreaFilled(false);
    bt_tabs5.setContentAreaFilled(false);
    bt_info5.setContentAreaFilled(false);
    bt_menu5.setFocusPainted(false);
    bt_tool_bar5.setFocusPainted(false);
    bt_tabs5.setFocusPainted(false);
    bt_info5.setFocusPainted(false);
    bt_menu5.setFocusable(false);
    bt_tool_bar5.setFocusable(false);
    bt_tabs5.setFocusable(false);
    bt_info5.setFocusable(false);
    bt_menu5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(1);} catch (Exception t3) {}
      }
    });
    bt_tool_bar5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_tabs5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    bt_info5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
          try{ TextPane.setCaretPosition(0); TextPane.setCaretPosition(Integer.parseInt((e).getActionCommand())); } catch (Exception t3) {}
      }
    });
    s = sdoc.addStyle("bt_menu5", s);
    StyleConstants.setComponent(s, bt_menu5);
    s = sdoc.addStyle("bt_tool_bar5", s);
    StyleConstants.setComponent(s, bt_tool_bar5);
    s = sdoc.addStyle("bt_tabs5", s);
    StyleConstants.setComponent(s, bt_tabs5);
    s = sdoc.addStyle("bt_info5", s);
    StyleConstants.setComponent(s, bt_info5);
    //Using the Menu
    sdoc.insertString(sdoc.getLength(), java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("The_documentation_is_automatically_generated_depending_on_presence_of_elements"), sdoc.getStyle("txt_size8"));
    sdoc.insertString(sdoc.getLength(), "\n\n", def);
    sdoc.insertString(sdoc.getLength(), "bt_menu", sdoc.getStyle("bt_menu1"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tool_bar", sdoc.getStyle("bt_tool_bar1"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tabs", sdoc.getStyle("bt_tabs1"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_info1", sdoc.getStyle("bt_info1"));
    sdoc.insertString(sdoc.getLength(), "\n\n", def);
    for(int i=0; i<jMenuBar1.getMenuCount(); i++){
        JMenu m = jMenuBar1.getMenu(i);
        sdoc.insertString(sdoc.getLength(), m.getText(), sdoc.getStyle("txt_bold_grey"));
        sdoc.insertString(sdoc.getLength(), (m.getToolTipText()!=null?(" - "+m.getToolTipText()):"")+"\n", def);
        for(int j=0; j<m.getItemCount(); j++){
            JMenuItem m_item = m.getItem(j);
            if(m_item!=null){
                sdoc.insertString(sdoc.getLength(), "\t", def);
                sdoc.insertString(sdoc.getLength(), m_item.getText(), sdoc.getStyle("txt_bold_grey"));
                sdoc.insertString(sdoc.getLength(), (m_item.getToolTipText()!=null?(" - "+m_item.getToolTipText()):"")+"\n", def);
                if(m_item instanceof JMenu){
                    JMenu subm = (JMenu)m_item;
                    for(int k=0; k<subm.getItemCount(); k++){
                        JMenuItem m_subitem = subm.getItem(k);
                        JButton jbt = new JButton(m_subitem.getIcon());
                        jbt.setContentAreaFilled(false);
                        jbt.setFocusPainted(false);
                        jbt.setFocusable(false);
                        jbt.setMargin(new Insets(0, 0, 0, 0));
                        jbt.setActionCommand(m_subitem.getActionCommand());
                        jbt.setToolTipText(m_subitem.getText());
                        jbt.addActionListener(new java.awt.event.ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                showHelp(w_help,e.getActionCommand(),((JButton)e.getSource()).getToolTipText());
                            }
                        });
                        s = sdoc.addStyle("icon"+k, s);
                        StyleConstants.setComponent(s, jbt);
                        sdoc.insertString(sdoc.getLength(), "\t", def);
                        sdoc.insertString(sdoc.getLength(), ""+k, sdoc.getStyle("icon"+k));
                        sdoc.insertString(sdoc.getLength(), " "+m_subitem.getText()+"\n", def);
                        //sdoc.insertString(sdoc.getLength(), (m_subitem.getToolTipText()!=null?(" - "+m_subitem.getToolTipText()):"")+"\n", def);
                    }
                    sdoc.insertString(sdoc.getLength(), "\n", def);
                }
            }
        }
        sdoc.insertString(sdoc.getLength(), "\n", def);
    }
    bt_tool_bar2.setActionCommand(""+sdoc.getLength());
    bt_tool_bar3.setActionCommand(""+sdoc.getLength());
    bt_tool_bar4.setActionCommand(""+sdoc.getLength());
    bt_tool_bar5.setActionCommand(""+sdoc.getLength());
    sdoc.insertString(sdoc.getLength(), "\n\n\n", def);
    sdoc.insertString(sdoc.getLength(), "bt_menu", sdoc.getStyle("bt_menu2"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tool_bar", sdoc.getStyle("bt_tool_bar2"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tabs", sdoc.getStyle("bt_tabs2"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_info", sdoc.getStyle("bt_info2"));
    sdoc.insertString(sdoc.getLength(), "\n\n", sdoc.getStyle("txt_center"));
    for(int i=0; i<TB.getComponentCount(); i++){
       Component c = TB.getComponentAtIndex(i);
       if(c instanceof AbstractButton){
           AbstractButton abt = (AbstractButton)c;
           s = sdoc.addStyle("icon"+i, s);
           StyleConstants.setIcon(s, abt.getIcon());
           sdoc.insertString(sdoc.getLength(), ""+i, sdoc.getStyle("icon"+i));
           sdoc.insertString(sdoc.getLength(), (abt.getToolTipText()!=null?(" - "+abt.getToolTipText()):"")+"\n", def);
       }
    }
    bt_tool_bar1.setActionCommand(""+sdoc.getLength());
    bt_tabs4.setActionCommand(""+sdoc.getLength());
    bt_tabs5.setActionCommand(""+sdoc.getLength());
    sdoc.insertString(sdoc.getLength(), "\n\n\n", def);
    sdoc.insertString(sdoc.getLength(), "bt_menu", sdoc.getStyle("bt_menu3"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tool_bar", sdoc.getStyle("bt_tool_bar3"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tabs", sdoc.getStyle("bt_tabs3"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_info", sdoc.getStyle("bt_info3"));
    sdoc.insertString(sdoc.getLength(), "\n\n", def);
    bt_tabs1.setActionCommand(""+sdoc.getLength());
    bt_tabs2.setActionCommand(""+sdoc.getLength());
    bt_tabs3.setActionCommand(""+sdoc.getLength());
    for(int i=0; i<root_node_tree_menu.getChildCount(); i++){
        sdoc.insertString(sdoc.getLength(), root_node_tree_menu.getChildAt(i)+"\n", sdoc.getStyle("txt_bold_grey"));
        DefaultMutableTreeNode jtb = (DefaultMutableTreeNode)root_node_tree_menu.getChildAt(i);
        for(int j=0; jtb!=null && j<jtb.getChildCount(); j++){
            JToggleButton jbt_tb = (JToggleButton)((DefaultMutableTreeNode)jtb.getChildAt(j)).getUserObject();
            JButton jbt = new JButton(jbt_tb.getIcon());
            jbt.setContentAreaFilled(false);
            jbt.setFocusPainted(false);
            jbt.setFocusable(false);
            jbt.setMargin(new Insets(0, 0, 0, 0));
            jbt.setActionCommand(jbt_tb.getActionCommand());
            jbt.setToolTipText(jbt_tb.getToolTipText());
            jbt.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    showHelp(w_help,e.getActionCommand(),((JButton)e.getSource()).getToolTipText());
                }
            });
            s = sdoc.addStyle("jbt_tb"+j, s);
            StyleConstants.setComponent(s, jbt);
            sdoc.insertString(sdoc.getLength(), " ", def);
            sdoc.insertString(sdoc.getLength(), ""+j, sdoc.getStyle("jbt_tb"+j));
            sdoc.insertString(sdoc.getLength(), " "+jbt_tb.getToolTipText()+"\n", def);
        }
        sdoc.insertString(sdoc.getLength(), "\n", def);
    }
    bt_info5.setActionCommand(""+sdoc.getLength());
    sdoc.insertString(sdoc.getLength(), "\n\n\n", def);
    sdoc.insertString(sdoc.getLength(), "bt_menu", sdoc.getStyle("bt_menu4"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tool_bar", sdoc.getStyle("bt_tool_bar4"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tabs", sdoc.getStyle("bt_tabs4"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_info", sdoc.getStyle("bt_info4"));
    sdoc.insertString(sdoc.getLength(), "\n\n", def);
    sdoc.insertString(sdoc.getLength(), "InetAddress.LocalHost:\t", sdoc.getStyle("txt_bold"));
    sdoc.insertString(sdoc.getLength(), InetAddress.getLocalHost()+"\n", def);
    sdoc.insertString(sdoc.getLength(), "InetAddress.Name:\t", sdoc.getStyle("txt_bold"));
    sdoc.insertString(sdoc.getLength(), InetAddress.getByName("")+"\n", def);
    bt_info1.setActionCommand(""+sdoc.getLength());
    bt_info2.setActionCommand(""+sdoc.getLength());
    bt_info3.setActionCommand(""+sdoc.getLength());
    bt_info4.setActionCommand(""+sdoc.getLength());
    Properties prop = System.getProperties();
    for (Enumeration ep = prop.keys(); ep.hasMoreElements();){
        Object key = ep.nextElement();
        sdoc.insertString(sdoc.getLength(), key+":\t", sdoc.getStyle("txt_bold"));
        sdoc.insertString(sdoc.getLength(), prop.get(key)+"\n", def);
    }
    Hashtable env = new Hashtable(System.getenv());
    for (Enumeration ep = env.keys(); ep.hasMoreElements();){
        Object key = ep.nextElement();
        sdoc.insertString(sdoc.getLength(), key+":\t", sdoc.getStyle("txt_bold"));
        sdoc.insertString(sdoc.getLength(), env.get(key)+"\n", def);
    }
    sdoc.insertString(sdoc.getLength(), "\n\n", def);
    sdoc.insertString(sdoc.getLength(), "bt_menu", sdoc.getStyle("bt_menu5"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tool_bar", sdoc.getStyle("bt_tool_bar5"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_tabs", sdoc.getStyle("bt_tabs5"));
    sdoc.insertString(sdoc.getLength(), "   ", def);
    sdoc.insertString(sdoc.getLength(), "bt_info", sdoc.getStyle("bt_info5"));
    sdoc.insertString(sdoc.getLength(), "\n", def);
    TextPane.setCaretPosition(0);
    w_help.getContentPane().add(sp, BorderLayout.CENTER);
    sp.getViewport().add(TextPane, null);
    TextPane.setEditable(false);
    //==========================================================================
    } catch (Exception t2) {}
    w_help.show();
    w_help.setState(Frame.NORMAL);
  }

  public void showHelp(String doc, String title){
      showHelp(this, doc, title);
  }

  public void showHelp(Frame f, String doc, String title){
    JDialog d = new JDialog(f,title);
    d.setSize(600,300);
    JScrollPane sp = new JScrollPane();
    JEditorPane EditorPane = new JEditorPane();
    sp.getViewport().add(EditorPane, null);
    try{
      EditorPane.setPage(JMCAD.class.getResource("help/"+doc+"_"+Locale.getDefault()+".html"));
    }catch(Exception e) {
      try{
        EditorPane.setPage(JMCAD.class.getResource("help/"+doc+".html"));
      }catch(Exception e1) { }
    }
    EditorPane.setEditable(false);
    d.getContentPane().add(sp);
    d.setVisible(true);
  }

  void b_erase_actionPerformed(ActionEvent e) {
    if(desktop.getSelectedFrame()==null)return;
    JMCADDocument doc = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
    Component[] comp = doc.getComponents();
    for(int i=0; i<comp.length; i++){
      Object[] out_obj = ((JMCADObject)comp[i]).out_obj;
      int[] out_obj_index = ((JMCADObject)comp[i]).out_obj_index;
      for(int j=0; j<out_obj.length; j++){
        try{
          if(((JButton)((JMCADObject)out_obj[j]).panel_in.getComponent(out_obj_index[j])).getBackground()==Color.red){
            ((JButton)((JMCADObject)out_obj[j]).panel_in.getComponent(out_obj_index[j])).setBackground(new JButton().getBackground());
            out_obj[j]=null;
          }
        }catch(Exception e1) { }
      }
    }
    for(int i=0; i<comp.length; i++){
      Object[] out_obj = ((JMCADObject)comp[i]).out_obj;
      Component[] out_button = ((JMCADObject)comp[i]).panel_out.getComponents();
      for(int j=0; j<out_button.length; j++){
        try{
          if(((JButton)out_button[j]).getBackground()==Color.red){
            out_obj[j]=null;
            ((JButton)out_button[j]).setBackground(new JButton().getBackground());
          }
        }catch(Exception e1) { }
      }
    }

    for(int i=comp.length-1; i>=0; i--){
      if(((JMCADObject)comp[i]).isSelected){
        doc.remove(i);
      }
    }

    doc.repaint();
  }
  void b_visual_actionPerformed(ActionEvent e) {
      if(desktop.getSelectedFrame()==null) return;
      JMCADDocument doc_src = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
      int res = JOptionPane.showInternalConfirmDialog(desktop,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save")+": "+desktop.getSelectedFrame().getTitle(),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save"),JOptionPane.YES_NO_OPTION);
      if(res==0)  b_save_actionPerformed(null);
      else return;
      doc_visual = JMCADDocument.Document_Open(doc_src.getFileName());
      doc_visual.Document_setVisual(true);
      JDialog d = new JDialog(this, desktop.getSelectedFrame().getTitle(), true);
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      if(doc_visual.window_visual_w==0 && doc_visual.window_visual_h==0){
          doc_visual.window_visual_w=doc_src.window_w;
          doc_visual.window_visual_h=doc_src.window_h;
      }
      doc_visual.Document_setDebug(false);
      d.setSize(doc_visual.window_visual_w, doc_visual.window_visual_h);
      d.setLocation((screenSize.width-doc_visual.window_visual_w)/2,(screenSize.height-doc_visual.window_visual_h)/2);
      d.getContentPane().setLayout(new BorderLayout());
      d.getContentPane().add(doc_visual, BorderLayout.CENTER);
      d.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          JDialog dd = (JDialog)e.getSource();
          dd.setDefaultCloseOperation(JInternalFrame.DO_NOTHING_ON_CLOSE);
          int res = JOptionPane.showConfirmDialog(dd,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save")+": "+dd.getTitle(),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save"),JOptionPane.YES_NO_CANCEL_OPTION);
          if(res==0){
              JMCADDocument doc_src = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
              doc_src.window_visual_w = dd.getWidth();
              doc_src.window_visual_h = dd.getHeight();
              Component[] comp = ((JMCADDocument)dd.getContentPane().getComponent(0)).getComponents();
              for(int i=0; i<comp.length; i++){
                  JMCADObject obj = (JMCADObject)comp[i];
                  if(obj.isVisual){
                      System.out.println(obj.Id);
                      Component[] comp_src = doc_src.getComponents();
                      for(int j=0; j<comp_src.length; j++){
                          JMCADObject obj_src = (JMCADObject)comp_src[j];
                          if(obj_src.Id.compareToIgnoreCase(obj.Id)==0){
                              obj_src.position_visual_x = obj.getLocation().x;
                              obj_src.position_visual_y = obj.getLocation().y;
                              obj_src.size_visual_w = obj.w;
                              obj_src.size_visual_h = obj.h;
                          }
                      }
                  }
              }
          }
          if(res!=2){
            ((JDialog)e.getSource()).setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
            ((JMCADDocument)((JDialog)e.getSource()).getContentPane().getComponent(0)).Document_Calc_Stop();
          }
        }
      });
      d.setVisible(true);
  }
  void b_saveas_actionPerformed(ActionEvent e) {
      if(desktop.getSelectedFrame()==null) return;
      JMCADDocument doc = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
      String st = doc.getFileName();
      doc.setFileName(null);
      b_save_actionPerformed(e);
      if(doc.getFileName()==null && st!=null) doc.setFileName(st);
  }
  void b_save_actionPerformed(ActionEvent e) {
    try {
      if(desktop.getSelectedFrame()==null) return;
      JMCADDocument doc = (JMCADDocument)desktop.getSelectedFrame().getContentPane().getComponent(0);
      JInternalFrame jif = (JInternalFrame)desktop.getSelectedFrame();
      Rectangle r = jif.getBounds();
      doc.window_x = r.x;
      doc.window_y = r.y;
      doc.window_w = r.width;
      doc.window_h = r.height;
      String st = doc.getFileName();
      if(st==null){
        FileNameExtensionFilter filter = new FileNameExtensionFilter(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save_JMCAD_model_*.jmcad"), "jmcad");
        try {
            JFileChooser fd = new JFileChooser(".");
            fd.addChoosableFileFilter(filter);
            int choise = fd.showSaveDialog(this);
            if(choise == JFileChooser.APPROVE_OPTION){
                File ff = fd.getSelectedFile();
                st = ff.getAbsolutePath();
            }else return;
        } catch(Exception e1) {e1.printStackTrace();}
      }
      doc.Document_Save(st);
      Load_List();
    } catch(Exception e1) {error(e1);}
  }

  public void b_open_document(){
        FileNameExtensionFilter filter = new FileNameExtensionFilter(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open_JMCAD_model_*.jmcad"), "jmcad");
        try {
            JFileChooser fd = new JFileChooser(".");
            fd.addChoosableFileFilter(filter);
            fd.setMultiSelectionEnabled(true);
            int choise = fd.showOpenDialog(this);
            if(choise == JFileChooser.APPROVE_OPTION){
                File[] f = fd.getSelectedFiles();
                if (fd.getFileFilter().equals(filter)) {
                    for(int i=0; i<f.length; i++){
                        Open_Document(f[i].getAbsolutePath());
                    }
                }
            }
        } catch(Exception e1) {e1.printStackTrace();}
    }

  
  public synchronized void Open_Document(String st_path) {
    try {
        JMCADDocument doc = JMCADDocument.Document_Open(st_path);
        if(isSingle){
            NewMainFrame();
            this.setBounds(doc.window_x, doc.window_y, doc.window_w, doc.window_h);
            this.getContentPane().add(doc, BorderLayout.CENTER);
            this.setTitle(VERSION+" "+st_path+(doc.doc_name.length()>0?" - "+doc.doc_name:""));
        } else {
            NewFrame();
            JInternalFrame frame = desktop.getSelectedFrame();
            frame.setVisible(false);
            frame.getContentPane().removeAll();
            frame.setBounds(doc.window_x, doc.window_y, doc.window_w, doc.window_h);
            b_debug.setSelected(doc.Document_isDebug());
            frame.setMaximum(doc.window_max);
            frame.getContentPane().add(doc, BorderLayout.CENTER);
            doc.setFileName(st_path);
            frame.setVisible(true);
        }
        doc.revalidate();
     } catch(Exception e1) {e1.printStackTrace();}
  }
  

  public void about(){
      JOptionPane.showMessageDialog(this,new JMCADAbout(),this.VERSION,JOptionPane.PLAIN_MESSAGE);
  }



}
