/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;

public class JMCADConfigPanel extends JPanel {
  public JTextField delay = new JTextField();
  public JTextField delay_debug = new JTextField(3);
  public JTextField name = new JTextField();
  public JTextField autor = new JTextField();
  public JTextArea info = new JTextArea();

  public JMCADConfigPanel() {
    try {
        this.setLayout(new BorderLayout());
        Border border = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
        TitledBorder titledBorder = new TitledBorder(border,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Document_description"));
        JScrollPane sp = new JScrollPane();
        info.setWrapStyleWord(true);
        info.setLineWrap(true);
        sp.setBorder(titledBorder);
        sp.setPreferredSize(new Dimension(12, 145));
        JPanel p1 = new JPanel(new BorderLayout());
        JPanel p2 = new JPanel(new BorderLayout());
        JPanel p3 = new JPanel(new BorderLayout());
        JPanel p4 = new JPanel(new BorderLayout());
        JPanel p5 = new JPanel(new BorderLayout());
        JPanel p6 = new JPanel(new BorderLayout());
        JPanel p7 = new JPanel(new GridLayout(2,1));
        p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Name")), BorderLayout.WEST);
        p1.add(name, BorderLayout.CENTER);
        p3.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Author")), BorderLayout.WEST);
        p3.add(autor, BorderLayout.CENTER);
        p4.add(sp, BorderLayout.CENTER);
        sp.getViewport().add(info);
        p5.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Delay")+", "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("ms")), BorderLayout.WEST);
        p5.add(delay, BorderLayout.CENTER);
        p6.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Delay")+" "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("for_debugging")+", "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("ms")), BorderLayout.WEST);
        p6.add(delay_debug, BorderLayout.CENTER);
        this.add(p1,BorderLayout.NORTH);
        this.add(p2,BorderLayout.CENTER);
        p7.add(p5);
        p7.add(p6);
        p2.add(p3,BorderLayout.NORTH);
        p2.add(p4,BorderLayout.CENTER);
        p2.add(p7,BorderLayout.SOUTH);
    } catch(Exception e) { e.printStackTrace(); }
  }
  
}
