/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class JMCADNewVersionInfo  extends Thread{
    String VERSION;

    public JMCADNewVersionInfo(String version){
        VERSION = version;
    }
    
    public void run() {
        String st = "";
        try {
            Thread.sleep(300000);
            URL url = new URL("ftp://www.mirrorservice.org/sites/kent.dl.sourceforge.net/pub/sourceforge/j/jm/jmcad/");
            URLConnection urlc = url.openConnection();
            InputStream in = urlc.getInputStream();
            int b;
            while((b=in.read())!=-1){
                st+=(char)b;
            }
            in.close();
            StringTokenizer stt = new StringTokenizer(st," \t\n");
            int ver_ftp = 0;
            int ver_jmcad = getVersion(VERSION);
            while(stt.hasMoreTokens()){
                String st1 = stt.nextToken();
                ver_ftp = Math.max(ver_ftp, getVersion(st1));
            }
            System.out.println("New JMCAD Version: "+ver_ftp);
            System.out.println("Current JMCAD Version: "+ver_jmcad);
            if(ver_ftp>ver_jmcad){
                int res = JOptionPane.showConfirmDialog(null,ResourceBundle.getBundle("JMCAD_Internationalize").getString("A_new_version_JMCAD_is_available!")+"\n"+ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open_site_for_downloading?"),java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("A_new_version_JMCAD_is_available!"),JOptionPane.YES_NO_OPTION);
                if(res==0) try{ Desktop.getDesktop().browse( new URI("http://jmcad.sf.net/")); }catch(Exception e1) {  }
            }
        }catch(Exception e){/*System.out.println("JMCADNewVersionInfo: "+e);*/}
    }
    
    private int getVersion(String st){
        int v = 0;
        try {
            if(st.indexOf('.')!=-1){
                StringTokenizer stt = new StringTokenizer(st,"jmcadJMCAD-.zipZIPtTrRlLwWnNeEbBqQyYuUoOsSfFgGhHkKxXvV \t\n");
                String st1 = stt.nextToken();
                String st2 = stt.nextToken();
                v = Integer.parseInt(st1+st2);
            }
        }catch(Exception e){System.out.println("JMCADNewVersionInfo: "+e); System.out.println(st);}
        return v;
    }

}
