/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class _acos extends JMCADObject {
  private JCheckBox cb0;
  private JCheckBox cb1;
  private int sel = 1;
  protected double k = 1;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("units = "+(sel==0?"G":"R")+"\n"); //Measurement units - grades or radians
  }
  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("UNITS")){
            st0 = stt0.nextToken();
            if(st0.equals("G")){ sel = 0; k=Math.PI/180; }else if(st0.equals("R")){ sel = 1; k = 1; }else error(ResourceBundle.getBundle("JMCAD_Internationalize").getString("The_parametre_is_not_correctly_set_-_")+st0);
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }


  public _acos() {
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 80;
    h = 10;
    ToolTipText = "OUT=acos(IN)";
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.setColor(Color.black);
    g.drawString("acos",5,16);
  }
  public void calc(){
    out[0]=Math.acos(in[0]*k);
    in[0]=Double.NaN;
  }
  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    cb0 = new JCheckBox(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Degrees"),false);
    cb1 = new JCheckBox(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Radians"),true);
    ButtonGroup BGroup = new ButtonGroup();
    JPanel p0 = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new BorderLayout());
    p0.add(cb0,BorderLayout.WEST);
    p1.add(cb1,BorderLayout.WEST);
    edit_panel.add(p0);
    edit_panel.add(p1);
    BGroup.add(cb0);
    BGroup.add(cb1);
    if(sel==0)cb0.setSelected(true); else cb1.setSelected(true);
  }
  public void edit_post(){
    if(cb0.isSelected()){
      k=Math.PI/180;
      sel=0;
    }else{
      sel=1;
      k=1;
    }
  }

}
