/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;

public class _branching_2 extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_branching_2.gif")).getImage();

  /**
   * Constructor element - creates and sets up the element.
   */
  public _branching_2() {
    ToolTipText = "OUT=IN";     // Text Tips
    // An array of input values
    in = new double[1];         // It creates an array of input values
    in[0] = Double.NaN;         // Set initial value for each entry ( in[0]=Double.NaN; ... in[...]=Double.NaN; )
    in_text = new String[1];    // Array for the help text. The size of the array must match the array of input values.
    in_text[0] = "IN";          // Set initial value for each element of the array help text (in_text[0]="..."; ... in_text[...] = "...";)
    // An array of output values
    out = new double[2];
    out[0] = Double.NaN; out[1] = Double.NaN;
    out_text = new String[2];
    out_text[0] = "OUT";
    out_text[1] = "OUT";
    out_obj = new Object[2];
    out_obj_index = new int[2];
    //The size of the element.
    w = 72;                     // w - width
    h = 36;                     // h - height
    // initialization settings
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }

  /**
   * The method describes how to draw an element in the window.
   */
  public void paint_info(Graphics g){
    g.setColor(Color.WHITE);
    g.fillRect(0, 0, w, h);
    g.drawImage(img,0,0,this);
  }

  /**
   * The method reads the value of inputs, and when all the values obtained
   * (not equal to NaN or Infinite) performs computations.
   *
   * The result is stored in the output ( out[0]=...; ... out[...]=...; )
   * and automatically sent to another element with which the connection.
   * 
   * All input values are assigned Double.NaN
   * ( in[0]=Double.NaN; ... in[...]=Double.NaN; ).
   */
  public void calc(){
    out[0]=in[0];
    out[1]=in[0];
    in[0]=Double.NaN;
  }


}
