/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;


public class _control_normally_closed_contact extends JMCADObject{
  public ImageIcon img_run = new ImageIcon(this.getClass().getResource("_control_normally_closed_contact.gif"));
  public ImageIcon img_stop = new ImageIcon(this.getClass().getResource("_control_normally_opened_contact.gif"));
  public JToggleButton bt = new JToggleButton();
  
  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("selected = "+bt.isSelected()+"\n");
  }

  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("SELECTED")){
            st0 = stt0.nextToken();
            try{ bt.setSelected(Boolean.parseBoolean(st0)); } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    this.remove(this.panel_c);
    this.add(bt,BorderLayout.CENTER);
  }

  public _control_normally_closed_contact() {
    this.isVisual = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("ON/OFF_for_the_is_normal-closed_contact");
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 76;
    h = 36;
    bt.setToolTipText(ToolTipText);
    bt.setIcon(img_run);
    bt.setSelectedIcon(img_stop);
    bt.setMargin(new Insets(0, 0, 0, 0));
    this.remove(this.panel_c);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    this.add(bt,BorderLayout.CENTER);
  }

  public void calc(){
    if(bt.isSelected()) out[0] = Double.POSITIVE_INFINITY; else out[0] = in[0];
    in[0]=Double.NaN;
  }

  public void paint_info(Graphics g){ }
  

}
