/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class _dev_in extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_dev_in.gif")).getImage();
  private JTextField tf = new JTextField();;
  private String device = "";
  private FileInputStream ins;
  private DataInputStream dins;

  
  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("device = "+device+"\n");
  }
  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("DEVICE")){
            try{ device = stt0.nextToken(); } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }
  
  public _dev_in() {
    ToolTipText = java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Input_in_the_document_from_the_device");
    in = new double[0];
    in_text = new String[0];
    out = new double[1];
    out[0] = Double.POSITIVE_INFINITY;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 67;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,0,0,this);
  }

  public void calc_pre(){
      try {
          ins = new FileInputStream(device);
          dins = new DataInputStream(ins);
      }catch(Exception e) { error(e);  }
  }

  public void calc(){
      try {
           out[0] = dins.readDouble();
           in[0]=Double.NaN;
      }catch(Exception e) { }
  }

  public void calc_post(){
      try {
          dins.close();
          ins.close();
      }catch(Exception e) { error(e); }
  }

  
  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    tf.setText(device+"");
    edit_panel.add(new JLabel(java.util.ResourceBundle.getBundle("JMCAD_Internationalize").getString("Device")),BorderLayout.WEST);
    edit_panel.add(tf,BorderLayout.CENTER);
    edit_panel.add(new JLabel(" "),BorderLayout.NORTH);
    edit_panel.add(new JLabel(" "),BorderLayout.SOUTH);
  }
  public void edit_post(){
    try {
        device = tf.getText();
    }catch(Exception e) { error(e); }
  }
  
}
