/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import java.util.*;
import java.awt.*;

public class _dt_control extends JMCADObject {

  public _dt_control() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Delay")+", "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("ms")+". "+ResourceBundle.getBundle("JMCAD_Internationalize").getString("It_is_set_in_model_parametres");
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 60;
    h = 10;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }

  public void paint_info(Graphics g){
    g.setColor(Color.black);
    g.drawString("dt",3,15);
  }

  public synchronized void start(long t0, long ti, long dt){
    if(Double.isNaN(in[0]) || Double.isInfinite(in[0])) out[0]=dt;
    else {
        getDocument().time_sleep = (long)in[0];
        out[0]=(long)in[0];
    }
    put();
  }


}
