/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class _filein extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_filein.gif")).getImage();
  private JTextField tf;
  private String file_name = "";
  private RandomAccessFile fin;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("file_in = "+file_name+"\n");
  }
  public void parse(String pst){
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("FILE_IN")){
            try{
              file_name = stt0.nextToken();
              } catch(Exception e3) {file_name = "";}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    if(file_name.length()!=0){
      try{
        fin = new RandomAccessFile(file_name,"r");
        String st;
        int count = 0;
        while((st=fin.readLine())!=null){
          if(!st.trim().startsWith("#") && !st.trim().startsWith("//") && st.trim().length()!=0){
            count = new StringTokenizer(st).countTokens();
            break;
          }
        }
        fin.close();
        w = 66;
        h = 36;
        out = new double[count];
        out_obj = new Object[count];
        out_obj_index = new int[count];
        for(int i=0; i<count; i++) out[i] = Double.NaN;
        out_text = new String[count];
        for(int i=0; i<count; i++) out_text[i] = "OUT"+i;
      } catch(Exception e1) {error(e1);}
    }
    super.parse(pst);
    try{ init(); } catch(Exception e2) {error(e2);}
  }

  public _filein() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Data_reading_from_a_file");
    in = new double[0];
    in_text = new String[0];
    out = new double[0];
    out_text = new String[0];
    out_obj = new Object[0];
    out_obj_index = new int[0];
    w = 60;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }

  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    tf = new JTextField();
    JPanel p0 = new JPanel(new BorderLayout());
    tf.setText(file_name==null?"":file_name);
    JButton b = new JButton("...");
    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try {
          FileDialog fd = new FileDialog(getFrame(),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Open_data_file"),FileDialog.LOAD);
          fd.setDirectory(".");
          fd.show();
          file_name=fd.getDirectory()+fd.getFile();
          if(fd.getFile()!=null){
            tf.setText(file_name);
          }
        } catch(Exception e1) {error(e1);}

      }
    });
    p0.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Name_of_a_file_with_data")),BorderLayout.NORTH);
    p0.add(tf,BorderLayout.CENTER);
    p0.add(b,BorderLayout.EAST);
    edit_panel.add(p0);
  }
  public void edit_post(){
    try {
      file_name=tf.getText();
      if(file_name.trim().length()==0){
        error(ResourceBundle.getBundle("JMCAD_Internationalize").getString("The_name_of_a_file_with_data_is_not_set!"));
        return;
      }
      fin = new RandomAccessFile(file_name,"r");
      String st;
      int count = 0;
      while((st=fin.readLine())!=null){
        if(!st.trim().startsWith("#") && !st.trim().startsWith("//") && st.trim().length()!=0){
          count = new StringTokenizer(st).countTokens();
          break;
        }
      }
      fin.close();
      w = 66;
      h = 36;
      out = new double[count];
      out_obj = new Object[count];
      out_obj_index = new int[count];
      for(int i=0; i<count; i++) out[i] = Double.NaN;
      out_text = new String[count];
      for(int i=0; i<count; i++) out_text[i] = "OUT"+i;
      try { init(); }catch(Exception e) { e.printStackTrace(); }
      this.getParent().validate();
      this.revalidate();
    }catch(Exception e) { error(e); }
  }
  public void calc_pre(){
    try{
      fin = new RandomAccessFile(file_name,"r");
    }catch(Exception e) { error(e); }
  }
  public void calc_post(){
    try{
      fin.close();
    }catch(Exception e) { error(e); }
  }
  public synchronized void start(long t0, long ti, long dt){
    try {
      if(fin==null) return;
      String st=fin.readLine();
      if(st==null)getDocument().Document_Calc_Stop();
      while(st!=null && (st.trim().startsWith("#") || st.trim().startsWith("//") || st.trim().length()==0)){
        st=fin.readLine();
      }
      if(st==null)getDocument().Document_Calc_Stop();
      try {
        StringTokenizer stt = new StringTokenizer(st," ,\t");
        for(int i=0; stt.hasMoreTokens(); i++) out[i] = Double.parseDouble(stt.nextToken());
      }catch(Exception e1) {}
      put();
    }catch(Exception e) {}
  }

  
  
}
