/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class _fileout extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_fileout.gif")).getImage();
  private JTextField tf;
  private JTextField tf_in;
  private int count = 0;
  private String file_name;
  private RandomAccessFile fin;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("file_in = "+file_name+"\n");
    fout.writeBytes("amount_in = "+count+"\n");
  }
  public void parse(String pst){
    //super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("FILE_IN")){
            try{
              file_name = stt0.nextToken();
            } catch(Exception e3) {file_name = "";}
          }else if(st0.equalsIgnoreCase("AMOUNT_IN")){
            try{
              st0 = stt0.nextToken();
              count = Integer.parseInt(st0);
            } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    if(count==0) w = 60; else w = 78;
    h = 36;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Data_recording_in_a_file")+" - "+file_name;
    in = new double[count];
    in_text = new String[count];
    out = new double[count];
    out_text = new String[count];
    out_obj = new Object[count];
    out_obj_index = new int[count];
    for(int i=0; i<count; i++){
      in[i] = Double.NaN;
      in_text[i]="IN"+i;
      out[i] = Double.NaN;
      out_text[i]="OUT"+i;
    }
    super.parse(pst);
    try{ init(); } catch(Exception e2) {error(e2);}
  }

  public _fileout() {
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Data_recording_in_a_file");
    w = 60;
    h = 36;
    this.panel_c.setBackground(Color.YELLOW);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }

  public void calc(){
    String st = "";
    for(int i=0; i<in.length; i++){
      out[i]=in[i];
      st+=out[i]+"\t";
      in[i]=Double.NaN;
    }
    if(fin!=null){
      try{ fin.writeBytes(st+"\n"); }catch(Exception e) {}
    }
  }
  public void calc_pre(){
    try{
      fin = new RandomAccessFile(file_name,"rw");
    }catch(Exception e) { error(e); }
  }
  public void calc_post(){
    try{
      fin.close();
    }catch(Exception e) { error(e); }
  }
  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    tf = new JTextField();
    tf_in = new JTextField();
    JPanel p0 = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new BorderLayout());
    tf.setText(file_name==null?"":file_name);
    tf_in.setText(""+count);
    JButton b = new JButton("...");
    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        try {
          FileDialog fd = new FileDialog(getFrame(),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Save_data"),FileDialog.SAVE);
          fd.setDirectory(".");
          fd.show();
          file_name=fd.getDirectory()+fd.getFile();
          if(fd.getFile()!=null){
            tf.setText(file_name);
          }
        } catch(Exception e1) {error(e1);}

      }
    });
    p0.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Name_of_a_file_for_data_recording")),BorderLayout.NORTH);
    p0.add(tf,BorderLayout.CENTER);
    p0.add(b,BorderLayout.EAST);
    p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Amount_of_inputs")),BorderLayout.NORTH);
    p1.add(tf_in,BorderLayout.CENTER);
    edit_panel.add(p0);
    edit_panel.add(p1);
  }
  public void edit_post(){
    try {
      file_name=tf.getText();
      if(file_name.trim().length()==0){
        error(ResourceBundle.getBundle("JMCAD_Internationalize").getString("The_name_of_a_file_for_data_recording_is_not_set!"));
        return;
      }
      count=Integer.parseInt(tf_in.getText());
      if(count==0) w = 60; else w = 76;
      h = 36;
      ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Data_recording_in_a_file")+" - "+file_name;
      in = new double[count];
      in_text = new String[count];
      out = new double[count];
      out_text = new String[count];
      out_obj = new Object[count];
      out_obj_index = new int[count];
      for(int i=0; i<count; i++){
        in[i] = Double.NaN;
        in_text[i]="IN"+i;
        out[i] = Double.NaN;
        out_text[i]="OUT"+i;
      }
      init();
      this.revalidate();
    }catch(Exception e) { error(e); }
  }


}
