/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;

public class _function extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_function.gif")).getImage();
  private JTextField tfx;
  private JTextField tff;
  private String st_param="IN", st_function="IN";

  
  public _function() {
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Does_not_work!")+ResourceBundle.getBundle("JMCAD_Internationalize").getString("Function_defined_by_the_user")+" OUT=f(...)";
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 76;
    h = 36;
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }
  public void calc(){
    out[0]=in[0];
    in[0]=Double.NaN;
  }
  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    tfx = new JTextField();
    tff = new JTextField();
    JPanel p0 = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new BorderLayout());
    tfx.setText(st_param);
    p0.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Parametres")),BorderLayout.WEST);
    p0.add(tfx,BorderLayout.CENTER);
    tff.setText(st_function);
    p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Function")),BorderLayout.WEST);
    p1.add(tff,BorderLayout.CENTER);
    edit_panel.add(p0);
    edit_panel.add(p1);
  }
  public void edit_post(){
    w = 76;
    h = 36;
    st_param = tfx.getText();
    st_function = tff.getText().replaceAll(" ","");
    StringTokenizer stt = new StringTokenizer(st_param," ,");
    in = new double[stt.countTokens()];
    for(int i=0; i<in.length; i++) in[i] = Double.NaN;
    in_text = new String[stt.countTokens()];
    for(int i=0; stt.hasMoreTokens(); i++) in_text[i] = stt.nextToken();
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    this.getParent().validate();
    this.revalidate();
  }

}
