/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;

public class _lamp extends JMCADObject{
  public ImageIcon img_on = new ImageIcon(this.getClass().getResource("_lamp_on.gif"));
  public ImageIcon img_off = new ImageIcon(this.getClass().getResource("_lamp_off.gif"));
  public JLabel bt = new JLabel(img_off);
  public boolean isOn = false;
  
  public void parse(String pst){
    super.parse(pst);
    this.remove(this.panel_c);
    this.add(bt,BorderLayout.CENTER);
  }

  public _lamp() {
    this.isVisual = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("The_lamp_shows_a_signal_condition._ON/OFF_OUT=IN");
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 78;
    h = 36;
    bt.setBackground(Color.WHITE);
    bt.setForeground(Color.WHITE);
    this.setBackground(Color.WHITE);
    this.remove(this.panel_c);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    this.add(bt,BorderLayout.CENTER);
  }

   public void calc_pre(){
       isOn = false;
       bt.setIcon(img_off);
   }

   public void calc_post(){
       isOn = false;
       bt.setIcon(img_off);
   }

  public void calc(){
    if(isOn) {
        if (Double.isNaN(in[0]) || Double.isInfinite(in[0])){
            isOn = false;
            bt.setIcon(img_off);
        }
    }else{
        if (!Double.isNaN(in[0]) && !Double.isInfinite(in[0])){
            isOn = true;
            bt.setIcon(img_on);
        } 
    }
    out[0] = in[0];
  }

  public void paint_info(Graphics g){ }
  

}
