/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class _netin extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_netin.gif")).getImage();
  private Thread  thread_server_socket;
  private JTextField tf = new JTextField();;
  private ServerSocket server_socket;
  private Socket client_socket;
  private int port = 11011;
  private DataInputStream dis;
  private double in_value;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("port = "+port+"\n");
  }
  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("PORT")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ port = Integer.parseInt(st0); } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }
  
  public _netin() {
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Input_in_the_document_for_network_connection_OUT=IN_if_there_is_no_connection_OUT=INFINITY");
    in = new double[0];
    in_text = new String[0];
    out = new double[1];
    out[0] = Double.POSITIVE_INFINITY;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 66;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,0,0,this);
  }

  public void calc_pre(){
      try {
          server_socket = new ServerSocket(port);
          thread_server_socket = new Thread() {
              public void run() {
                  while (true) try {
                    client_socket = server_socket.accept();
                    dis = new DataInputStream(client_socket.getInputStream());
                    while ((in_value = dis.readDouble()) != Double.NaN) {
                        out[0]=in_value;
                        put();
                    }
                  }catch(Exception e1) { 
                      out[0]=Double.POSITIVE_INFINITY;
                      put();
                      try { Thread.sleep(1000);}catch(Exception e2) {}
                  }
              }
          };
          thread_server_socket.start();
      }catch(Exception e) {
          error(e);
          getDocument().Document_Calc_Stop();
      }
  }

  public void calc_post(){
      try {
          thread_server_socket.yield();
          thread_server_socket = null;
          if(dis!=null)dis.close();
          if(client_socket!=null)client_socket.close();
          if(server_socket!=null)server_socket.close();
      }catch(Exception e) { error(e); }
  }

  
  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    tf.setText(port+"");
    edit_panel.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Port_of_network_connection")),BorderLayout.WEST);
    edit_panel.add(tf,BorderLayout.CENTER);
    edit_panel.add(new JLabel(" "),BorderLayout.NORTH);
    edit_panel.add(new JLabel(" "),BorderLayout.SOUTH);
  }
  public void edit_post(){
    try {
        port = Integer.parseInt(tf.getText());
    }catch(Exception e) { error(e); }
  }
  
}
