/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class _netout extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_netout.gif")).getImage();
  private Thread  thread;
  private JTextField tf_ip = new JTextField();
  private JTextField tf_port = new JTextField();
  private Socket socket;
  private DataOutputStream dos;
  private int port = 11011;
  private String inetAddress = "localhost";
  private boolean isConecting = false;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("port = "+port+"\n");
    fout.writeBytes("InetAddress = "+inetAddress+"\n");
  }
  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("PORT")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ port = Integer.parseInt(st0); } catch(Exception e3) {error(e3);}
          } else if(st0.equalsIgnoreCase("INETADDRESS")){
            inetAddress = stt0.nextToken();
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }

  public _netout() {
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Exit_from_the_document_for_network_connection_OUT=IN,_if_there_is_no_connection_OUT=INFINITY");
    in = new double[1];
    in_text = new String[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 76;
    h = 36;
    this.panel_c.setBackground(Color.YELLOW);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,0,0,this);
  }

  public void calc_pre(){
      try {
          socket = new Socket(inetAddress,port);
          dos = new DataOutputStream(socket.getOutputStream());
      }catch(Exception e) { /*error(e);*/ }
  }

  public void calc(){
    try {
        dos.writeDouble(in[0]);
        out[0]=in[0];
    }catch(Exception e) {
        out[0]=Double.POSITIVE_INFINITY;
        if(!isConecting)try {
          isConecting=true;
          thread = new Thread() {
              public void run() {
                  try {
                    socket = new Socket(inetAddress,port);
                    dos = new DataOutputStream(socket.getOutputStream());
                  }catch(Exception e2) { isConecting = false; }
                  isConecting = false;
              }
          };
          thread.start();
        }catch(Exception e1) { }
    }
    in[0]=Double.NaN;
  }

  public void calc_post(){
      try {
          dos.close();
          socket.close();
      }catch(Exception e) { error(e); }
  }

  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    tf_ip.setText(inetAddress);
    tf_port.setText(port+"");
    JPanel p0 = new JPanel(new BorderLayout());
    edit_panel.add(new JLabel("IP"),BorderLayout.WEST);
    p0.add(tf_ip,BorderLayout.CENTER);
    p0.add(new JLabel("Port"),BorderLayout.EAST);
    edit_panel.add(tf_port,BorderLayout.EAST);
    edit_panel.add(p0,BorderLayout.CENTER);
    edit_panel.add(new JLabel(" "),BorderLayout.NORTH);
    edit_panel.add(new JLabel(" "),BorderLayout.SOUTH);
  }
  public void edit_post(){
    try {
        int p = Integer.parseInt(tf_port.getText());
        String ip = tf_ip.getText();
        port = p;
        inetAddress = ip;
    }catch(Exception e) { error(e); }
  }


}
