/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;

public class _rectangular_wave extends JMCADObject{
  private final Image img = new ImageIcon(this.getClass().getResource("_rectangular_wave.gif")).getImage();
  JTextField tf_a = new JTextField();
  JTextField tf_b = new JTextField();
  JTextField tf_c = new JTextField();
  long a=500,b=200;
  double c=50;

  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("a = "+a+"\n");
    fout.writeBytes("b = "+b+"\n");
    fout.writeBytes("c = "+c+"\n");
  }

  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("A")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ a = Long.parseLong(st0); } catch(Exception e3) {error(e3);}
          }else if(st0.equalsIgnoreCase("B")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ b = Long.parseLong(st0); } catch(Exception e3) {error(e3);}
          }else if(st0.equalsIgnoreCase("C")){
            st0 = stt0.nextToken();
            if(!st0.equalsIgnoreCase("NAN"))  try{ c = Double.parseDouble(st0); } catch(Exception e3) {error(e3);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }

  public _rectangular_wave() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Rectangular_impulses");
    in = new double[0];
    in_text = new String[0];
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 70;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    edit_panel.add(new JLabel(new ImageIcon(this.getClass().getResource("_rectangular_wave_cfg.gif"))),BorderLayout.CENTER);
    JPanel p = new JPanel(new GridLayout(3,1));
    JPanel p1 = new JPanel(new BorderLayout());
    JPanel p2 = new JPanel(new BorderLayout());
    JPanel p3 = new JPanel(new BorderLayout());
    tf_a.setText(a+"");
    tf_b.setText(b+"");
    tf_c.setText(c+"");
    p1.add(new JLabel("a = "),BorderLayout.WEST);
    p1.add(tf_a,BorderLayout.CENTER);
    p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("ms")),BorderLayout.EAST);
    p2.add(new JLabel("b = "),BorderLayout.WEST);
    p2.add(tf_b,BorderLayout.CENTER);
    p2.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("ms")),BorderLayout.EAST);
    p3.add(new JLabel("c = "),BorderLayout.WEST);
    p3.add(tf_c,BorderLayout.CENTER);
    p3.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("double")),BorderLayout.EAST);
    edit_panel.add(p,BorderLayout.SOUTH);
    p.add(p1);
    p.add(p2);
    p.add(p3);
  }

  public void edit_post(){
    try {
      long ai = Long.parseLong(tf_a.getText());
      long bi = Long.parseLong(tf_b.getText());
      double ci = Double.parseDouble(tf_c.getText());
      a=ai; b=bi; c=ci;
    }catch(Exception e) { error(e); }
  }

  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }

  public synchronized void start(long t0, long ti, long dt){
    long dti = ti - t0;
    long k = dti / a;
    if((dti - (k * a))<=b) out[0]=c; else out[0]=0;
    put();
  }


}
