/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;

public class _rectangular_wave_control extends _rectangular_wave{
  private final Image img = new ImageIcon(this.getClass().getResource("_rectangular_wave_control.gif")).getImage();
  private long xt0,xti,xdt;

  

  public _rectangular_wave_control() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Rectangular_impulses_c_the_task_of_constant_values_or_with_operated_values");
    in = new double[3];
    in[0] = Double.NaN; in[1] = Double.NaN; in[2] = Double.NaN;
    in_text = new String[3];
    in_text[0] = "IN0(a)"; in_text[1] = "IN1(b)"; in_text[2] = "IN2(c)";
    out = new double[1];
    out[0] = Double.NaN;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 80;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }

  public void paint_info(Graphics g){
    g.drawImage(img,panel_c.getWidth()/2-18,panel_c.getHeight()/2-18,this);
  }

  public void start(long t0, long ti, long dt){
      xt0=t0; xti=ti; xdt=dt;
      if(Double.isNaN(in[0]) && Double.isNaN(in[1]) && Double.isNaN(in[2])) put();
  }
  

  public void calc(){
    if(!Double.isNaN(in[0]))a=Math.round(in[0]);
    if(!Double.isNaN(in[1]))b=Math.round(in[1]);
    if(!Double.isNaN(in[2]))c=in[2];
    long dti = xti - xt0;
    long k = dti / a;
    if((dti - (k * a))<=b) out[0]=c; else out[0]=0;
    in[0]=Double.NaN;
    in[1]=Double.NaN;
    in[2]=Double.NaN;
  }

}
