/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import javax.sound.sampled.*;
import java.awt.*;
import java.util.*;


public class _soundin extends JMCADObject {
  private final Image img = new ImageIcon(this.getClass().getResource("_soundin.gif")).getImage();
  private TargetDataLine tdl;
  private byte[] b = new byte[4];

  public _soundin() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Input_from_sound");
    in = new double[0];
    in_text = new String[0];
    out = new double[2];
    out[0] = Double.NaN;
    out[1] = Double.NaN;
    out_text = new String[2];
    out_text[0] = "OUT0";
    out_text[1] = "OUT1";
    out_obj = new Object[2];
    out_obj_index = new int[2];
    w = 66;
    h = 36;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,0,0,this);
  }

  public void calc_pre(){
    AudioFormat	audioFormat = new AudioFormat(AudioFormat.Encoding.PCM_SIGNED, 44100.0F, 16, 2, 4, 44100.0F, false);
    DataLine.Info	dataLineInfo = new DataLine.Info(TargetDataLine.class, audioFormat);
    try{
      tdl = (TargetDataLine) AudioSystem.getLine(dataLineInfo);
      tdl.open(audioFormat);
      tdl.start();
    }catch (Exception e){error(e);}
  }

  public synchronized void start(long t0, long ti, long dt){
    try{
      tdl.read(b, 0, 4);
      out[0]=(b[0] & 0xFF) | (b[1] << 8);
      out[1]=(b[2] & 0xFF) | (b[3] << 8);
    }catch (Exception e){error(e);}
    put();
  }

  

  public void calc_post(){
    try{
      tdl.stop();
      tdl.close();
    }catch (Exception e){error(e);}
  }



}
