/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.util.*;
import javax.sound.sampled.*;
import java.awt.*;

public class _soundout extends JMCADObject {
    private final Image img = new ImageIcon(this.getClass().getResource("_soundout.gif")).getImage();
    private float sampleRate = 8000.0F;
    //8000,11025,16000,22050,44100
    private int sampleSizeInBits = 16;
    //8,16
    private int channels = 1;
    //1,2
    private boolean signed = true;
    //true,false
    private boolean bigEndian = false;
    //true,false
    private SourceDataLine sourceDataLine;
    private AudioFormat audioFormat;
    private byte[] b = new byte[2];

  public _soundout() {
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Exit_from_the_document_on_the_device")+" SOUND OUT = IN";
    in = new double[1];
    in_text = new String[1];
    in[0] = Double.NaN;
    in_text[0] = "IN";
    out = new double[0];
    out_text = new String[0];
    out_obj = new Object[0];
    out_obj_index = new int[0];
    w = 66;
    h = 36;
    this.panel_c.setBackground(Color.YELLOW);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.drawImage(img,0,0,this);
  }
  public void calc_pre(){
      try {
        audioFormat = new AudioFormat(sampleRate, sampleSizeInBits, channels, signed,   bigEndian);
        DataLine.Info dataLineInfo =  new DataLine.Info(SourceDataLine.class, audioFormat);
        sourceDataLine = (SourceDataLine) AudioSystem.getLine(dataLineInfo);
        sourceDataLine.open(audioFormat);
        sourceDataLine.start();
      }catch(Exception e) { e.printStackTrace(); }
  }
  public void calc(){
      b[1] = b[0];
      b[0] = (byte) in[0];
      sourceDataLine.write(b, 0, 2);
      in[0]=Double.NaN;
  }
  public void calc_post(){
      sourceDataLine.drain();
      sourceDataLine.close();
  }
  


}
