/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.io.*;

public class _text extends JMCADObject{
  public JTextField txt_edit = new JTextField();
  public JTextField size_edit = new JTextField();
  public JLabel txt = new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Text")+"...");
  
  public void write(RandomAccessFile fout)  throws IOException{
    super.write(fout);
    fout.writeBytes("text = "+new String(txt.getText().getBytes("Cp1251"),"ISO8859_1")+"\n");
    fout.writeBytes("size = "+txt.getWidth()+"\n");
  }

  public void parse(String pst){
    super.parse(pst);
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        if(st.length()!=0){
          StringTokenizer stt0 = new StringTokenizer(st," =\t");
          String st0 = stt0.nextToken();
          if(st0.equalsIgnoreCase("TEXT")){
            try{
              String st_txt = stt0.nextToken();
              st_txt = new String(st_txt.substring(st_txt.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
              txt.setText(st_txt);
            }catch(Exception e2) {error(e2);}
          }else  if(st0.equalsIgnoreCase("SIZE")){
            try{
              w = Integer.parseInt(stt0.nextToken())+panel_in.getWidth()+panel_out.getWidth();
              txt.setPreferredSize(new Dimension(w, txt.getHeight()));
              this.setSize(w+20, h);
            }catch(Exception e2) {error(e2);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    this.remove(this.panel_c);
    this.add(txt,BorderLayout.CENTER);
  }

  public _text() {
    this.isVisual = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Text");
    in = new double[0];
    in_text = new String[0];
    out = new double[0];
    out_text = new String[0];
    out_obj = new Object[0];
    out_obj_index = new int[0];
    txt.setPreferredSize(new Dimension(100,txt.getPreferredSize().height));
    w = txt.getPreferredSize().width;
    h = txt.getPreferredSize().height;
    txt.setBackground(Color.WHITE);
    txt.setForeground(Color.BLACK);
    this.setBackground(Color.WHITE);
    this.remove(this.panel_c);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    this.add(txt,BorderLayout.CENTER);
  }

  public void edit_pre(){
    edit_panel = new JPanel(new VerticalFlowLayout());
    txt_edit.setText(txt.getText());
    size_edit.setText(txt.getWidth()+"");
    JPanel p0 = new JPanel(new BorderLayout());
    JPanel p1 = new JPanel(new BorderLayout());
    p0.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Text")),BorderLayout.WEST);
    p1.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Size")),BorderLayout.WEST);
    p0.add(txt_edit,BorderLayout.CENTER);
    p1.add(size_edit,BorderLayout.CENTER);
    edit_panel.add(p0);
    edit_panel.add(p1);
  }

  public void edit_post(){
    try {
      w = Integer.parseInt(size_edit.getText())+panel_in.getWidth()+panel_out.getWidth();
      txt.setText(txt_edit.getText());
      this.remove(this.panel_c);
      try { init(); }catch(Exception e) { e.printStackTrace(); }
      this.add(txt,BorderLayout.CENTER);this.getParent().validate();
      this.revalidate();
    }catch(Exception e) { error(e); }
  }
   

  public void paint_info(Graphics g){ }
  

}
