/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class _var extends JMCADObject {
  private JTextField tf;
  private double start_var = 0;

  public void write(RandomAccessFile fout)  throws IOException{
      super.write(fout);
      fout.writeBytes("value = "+start_var+"\n"); //Measurement units - grades or radians
    }
    public void parse(String pst){
      super.parse(pst);
      StringTokenizer stt = new StringTokenizer(pst,"\n");
      while(stt.hasMoreTokens()){
        try{
          String st = stt.nextToken();
          st=st.trim();
          if(st.length()!=0){
            StringTokenizer stt0 = new StringTokenizer(st," =,\t");
            String st0 = stt0.nextToken();
            if(st0.equalsIgnoreCase("VALUE"))  start_var = Double.parseDouble(stt0.nextToken());
          }
        } catch(Exception e1) {error(e1);}
      }
      try{ init(); } catch(Exception e2) {error(e2);}
  }

  public _var() {
    isGeneranor = true;
    ToolTipText = ResourceBundle.getBundle("JMCAD_Internationalize").getString("Variable");
    in = new double[1];
    in[0] = Double.NaN;
    in_text = new String[1];
    in_text[0] = "IN";
    out = new double[1];
    out[0] = start_var;
    out_text = new String[1];
    out_text[0] = "OUT";
    out_obj = new Object[1];
    out_obj_index = new int[1];
    w = 70;
    h = 10;
    this.panel_c.setBackground(Color.GREEN);
    try { init(); }catch(Exception e) { e.printStackTrace(); }
  }
  public void paint_info(Graphics g){
    g.setColor(Color.black);
    g.drawString("Var",5,15);
  }
  public void calc_pre(){
    out[0]=start_var;
    in[0]=Double.NaN;
  }
  public synchronized void start(long t0, long ti, long dt){
    if(!Double.isNaN(in[0]) && !Double.isInfinite(in[0])) out[0]=in[0];
    //out[0]=in[0];
    put();
  }
  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    tf = new JTextField();
    tf.setText(start_var+"");
    edit_panel.add(tf,BorderLayout.CENTER);
    edit_panel.add(new JLabel(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Value")),BorderLayout.WEST);
  }
  public void edit_post(){
    try {
      out[0]=Double.parseDouble(tf.getText());
      in[0]=Double.NaN;
    }catch(Exception e) { error(e); }
  }


}
