/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class JMCADRTC extends JFrame {
  private String VERSION = "JMCADRTC v 07.085 http://jmcad.sf.net";
  

  public JMCADRTC() {
    //new JMCADInfo().start();
    try {
      this.setTitle(VERSION);
      this.setResizable(false);
      addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          System.exit(0);
        }
      });
      
    }catch(Exception e) { e.printStackTrace(); }
  }
  public static void main(String[] args) {
	try {
        UIManager.put("swing.boldMetal", Boolean.FALSE);
        JDialog.setDefaultLookAndFeelDecorated(true);
        JFrame.setDefaultLookAndFeelDecorated(true);
        Toolkit.getDefaultToolkit().setDynamicLayout(true);
        System.setProperty("sun.awt.noerasebackground","true");
		UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
    }catch(Exception e) { e.printStackTrace(); }
    try {
        JMCADRTC jmcadrtc = new JMCADRTC();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        jmcadrtc.getContentPane().setLayout(new BorderLayout());
        JMCADRTCDocument doc = JMCADRTCDocument.Document_Open(args[0]);
        doc.Document_setVisual(true);
        jmcadrtc.setSize(doc.window_visual_w, doc.window_visual_h);
        jmcadrtc.setLocation((screenSize.width-doc.window_visual_w)/2,(screenSize.height-doc.window_visual_h)/2);
        jmcadrtc.getContentPane().add(doc, BorderLayout.CENTER);
        jmcadrtc.setVisible(true);
    }catch(Exception e) { e.printStackTrace(); }
  }


}
