/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */


import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.util.*;

public class JMCADObject extends JPanel{
  public String Id;
  public String ToolTipText;
  public JPanel edit_panel;
  private int x,y;
  public boolean isSelected;
  public boolean isGeneranor = false;
  private boolean isDragged;
  public boolean isVisual = false;
  public int w,h,size_visual_w,size_visual_h;
  public double[] in = {};
  public double[] out = {};
  public Object[] out_obj = {};
  public int[] out_obj_index = {};
  public String[] in_text = {};
  public String[] out_text = {};
  public JPanel panel_in;
  public JPanel panel_out;
  public JPanel panel_c;

  public void write(RandomAccessFile fout)  throws IOException{ }

  public void parse(String pst){
    StringTokenizer stt = new StringTokenizer(pst,"\n");
    while(stt.hasMoreTokens()){
      try{
        String st = stt.nextToken();
        st=st.trim().toUpperCase();
        if(st.length()!=0 && !st.startsWith("[")){
          StringTokenizer stt0 = new StringTokenizer(st," =,\t[]{}");
          String st0 = stt0.nextToken();
          if(st0.equals("POSITION")){
            this.setLocation(Integer.parseInt(stt0.nextToken()),Integer.parseInt(stt0.nextToken()));
          }else if(st0.equals("IN")){
            try{ in_text[Integer.parseInt(stt0.nextToken())]=stt0.nextToken(); } catch(Exception e2) {error(e2);}
          }else if(st0.equals("OUT")){
            try{
              int index = Integer.parseInt(stt0.nextToken());
              out_text[index]=stt0.nextToken();
              if(stt0.countTokens()==2){
                out_obj[index] = stt0.nextToken()+" "+stt0.nextToken();
              }
            } catch(Exception e2) {error(e2);}
          }
        }
      } catch(Exception e1) {error(e1);}
    }
    try{ init(); } catch(Exception e2) {error(e2);}
  }

  
  private void read_pre(){
    w = 62;
    h = 42;
    isSelected = false;
    isDragged = false;
    edit_panel = new JPanel(new BorderLayout());
    setLayout(new BorderLayout());
    panel_in = new JPanel();
    panel_out = new JPanel();
    VerticalFlowLayout VFlowLayout1 = new VerticalFlowLayout();
    VerticalFlowLayout VFlowLayout2 = new VerticalFlowLayout();
    VFlowLayout1.setAlignment(VerticalFlowLayout.CENTER);
    VFlowLayout2.setAlignment(VerticalFlowLayout.CENTER);
    panel_out.setLayout(VFlowLayout1);
    panel_in.setLayout(VFlowLayout2);
    panel_c = new JPanel(){
      public void paint(Graphics g){
        super.paint(g);
        paint_info(g);
      }
    };
    panel_c.setBorder(BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140)));
    panel_in.setBackground(Color.white);
    panel_out.setBackground(Color.white);
    this.add(panel_in, BorderLayout.WEST);
    this.add(panel_out, BorderLayout.EAST);
    this.add(panel_c, BorderLayout.CENTER);
  }
  public JMCADObject() {
    read_pre();
    try { init(); }catch(Exception e) { e.printStackTrace(); }
    this.revalidate();
  }

  public void paint(Graphics g){
    super.paint(g);
    ((Graphics2D)g).setStroke(new BasicStroke(5));
    if(isSelected && !isDragged){
      g.setColor(Color.red);
      g.drawRect(0,0,getWidth(),getHeight());
    }
  }
  public void init() throws Exception {
    h = Math.max(h,Math.max(in.length*(15)+5,out.length*(15)+5));
    this.setSize(w,h);
    setToolTipText(ToolTipText);
    this.removeAll();
    this.add(panel_in, BorderLayout.WEST);
    this.add(panel_out, BorderLayout.EAST);
    this.add(panel_c, BorderLayout.CENTER);
    panel_in.removeAll();
    panel_out.removeAll();
    panel_c.removeAll();
    for(int i=0; i<in.length; i++){
      JButton tb = new JButton();
      tb.setToolTipText(in_text[i]);
      tb.setPreferredSize(new Dimension(10,10));
      panel_in.add(tb);
    }
    for(int i=0; i<out.length; i++){
      JButton tb = new JButton();
      tb.setToolTipText(out_text[i]);
      tb.setPreferredSize(new Dimension(10,10));
      panel_out.add(tb);
    }
  }

  public void paint_info(Graphics g){
    g.setColor(Color.red);
    ((Graphics2D)g).setStroke(new BasicStroke(7));
    g.drawLine(0,0,panel_c.getWidth(),panel_c.getHeight());
    g.drawLine(0,panel_c.getHeight(),panel_c.getWidth(),0);
  }
  protected void edit(){
    edit_pre();
    Object[] b = {ResourceBundle.getBundle("JMCAD_Internationalize").getString("Ok"),ResourceBundle.getBundle("JMCAD_Internationalize").getString("Cancel")};
    int res = JOptionPane.showOptionDialog(this,edit_panel,ToolTipText,JOptionPane.YES_NO_OPTION,JOptionPane.PLAIN_MESSAGE,null,b,b[0]);
    if(res==0) edit_post(); 
  }

  protected void clear_in(){
    Component[] comp = getParent().getComponents();
    for(int i=0; i<comp.length; i++){
      Component[] comp_in = ((JMCADObject)comp[i]).panel_in.getComponents();
      for(int j=0; j<comp_in.length; j++){
        ((JButton)comp_in[j]).setBackground(new JButton().getBackground());
      }
    }
  }

  protected void clear_out(){
    Component[] comp = getParent().getComponents();
    for(int i=0; i<comp.length; i++){
      Component[] comp_out = ((JMCADObject)comp[i]).panel_out.getComponents();
      for(int j=0; j<comp_out.length; j++){
        ((JButton)comp_out[j]).setBackground(new JButton().getBackground());
      }
    }
  }

  private void join(){
    int obj_in=-1,obj_in_index=-1;
    Component[] comp = getParent().getComponents();
    for(int i=0; i<comp.length; i++){
      Component[] comp_in = ((JMCADObject)comp[i]).panel_in.getComponents();
      for(int j=0; j<comp_in.length; j++){
        if(((JButton)comp_in[j]).getBackground()==Color.red){
          obj_in = i;
          obj_in_index = j;
        }
      }
    }
    for(int i=0; i<comp.length; i++){
      Component[] comp_out = ((JMCADObject)comp[i]).panel_out.getComponents();
      for(int j=0; j<comp_out.length; j++){
        if(((JButton)comp_out[j]).getBackground()==Color.red && obj_in!=-1){
          ((JMCADObject)comp[i]).out_obj[j]=comp[obj_in];
          ((JMCADObject)comp[i]).out_obj_index[j]=obj_in_index;
          clear_in();
          clear_out();
        }
      }
    }
    this.getParent().repaint();
  }

  public synchronized void start(long t0, long ti, long dt){ }

  
  public synchronized void calc_pre(){ }
  public synchronized void calc(){ }
  public synchronized void calc_post(){ }

  public Frame getFrame(Component component){
    for(; component != null && !(component instanceof Frame); component = component.getParent());
    return (Frame)component;
  }

  public Frame getFrame(){ return getFrame(this); }

  protected void set(double v, int i){
    try{
      in[i]=v;
      if(isSet()) put();
    }catch(Exception e) { e.printStackTrace(); }
  }

  public void edit_pre(){
    edit_panel = new JPanel(new BorderLayout());
    edit_panel.add(new JLabel(ToolTipText),BorderLayout.CENTER);
  }
  public void edit_post(){ }
  protected void error(Object st){
    JOptionPane.showMessageDialog(this,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error:")+st,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error!"),JOptionPane.ERROR_MESSAGE);
    if(st instanceof Exception) ((Exception)st).printStackTrace(); else System.out.println("Error: "+st);
  }
  protected void put(){
    try{
      calc();
      for(int i=0; i<out.length; i++){
        try{
          ((JMCADObject)out_obj[i]).set(out[i],out_obj_index[i]);
        }catch(Exception e) { }
      }
    }catch(Exception e) { e.printStackTrace(); }
  }

  private boolean isSet(){
    boolean res = true;
    for(int i=0; i<in.length; i++) if(Double.isNaN(in[i])) return false;
    return res;
  }

  protected JMCADRTSDocument getDocument(){
    Component component = this;
    for(; component != null && !(component instanceof JMCADRTSDocument); component = component.getParent());
    return (JMCADRTSDocument)component;
  }

  
}
