/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOUSE. See the GNU
 * General Public License for more details.
 *
 * You should have recieved a copy of the GNU General Public License
 * along with this program; if not write to the Free Software
 * Foundation, inc., 59 Temple Place, Suite 330, Boston MA 02111-1307
 * USA
 */


/**
 *
 * @author Yuriy Mikhaylovskiy
 * @email YuriyMikhaylovskiy@yahoo.com
 * 
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class JMCADRTS extends JFrame {
  private String VERSION = "JMCADRTS v 07.085 http://jmcad.sf.net";
  
  public JMCADRTS() {
    //new JMCADInfo().start();
    try {
      this.setTitle(VERSION);
      this.setResizable(false);
      addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          System.exit(0);
        }
      });
    }catch(Exception e) { e.printStackTrace(); }
  }
  public static void main(String[] args) {
	try {
        UIManager.put("swing.boldMetal", Boolean.FALSE);
        JDialog.setDefaultLookAndFeelDecorated(true);
        JFrame.setDefaultLookAndFeelDecorated(true);
        Toolkit.getDefaultToolkit().setDynamicLayout(true);
        System.setProperty("sun.awt.noerasebackground","true");
		UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
    }catch(Exception e) { e.printStackTrace(); }
    try {
      JMCADRTS jmcad = new JMCADRTS();
      jmcad.Open_Document(args[0]);
      jmcad.setVisible(true);
      jmcad.validate();
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      jmcad.setLocation((screenSize.width-jmcad.getWidth())/2,(screenSize.height-jmcad.getHeight())/2);
    }catch(Exception e) { e.printStackTrace(); }
  }

  

  public void error(Object st){
    JOptionPane.showMessageDialog(this,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error:")+st,ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error!"),JOptionPane.ERROR_MESSAGE);
    if(st instanceof Exception) ((Exception)st).printStackTrace(); else System.out.println(ResourceBundle.getBundle("JMCAD_Internationalize").getString("Error:")+st);
  }


  public void Open_Document(String st_path) {
    try {    
        String path=st_path;
        JMCADRTSDocument doc = new JMCADRTSDocument();
        this.getContentPane().add(doc, BorderLayout.CENTER);
        RandomAccessFile fin = new RandomAccessFile(path,"rw");
        String st,st_obj=null;
        while((st=fin.readLine())!=null){
          if(st.startsWith("[")){
            if(st_obj!=null && st_obj.startsWith("[")){
              StringTokenizer stt = new StringTokenizer(st_obj,"[] =\t");
              String st_Id = stt.nextToken();
              JMCADObject obj = (JMCADObject)Class.forName(stt.nextToken()).newInstance();
              obj.Id = st_Id;
              obj.parse(st_obj);
              doc.add(obj);
            }else if(st_obj!=null){
              StringTokenizer stt = new StringTokenizer(st_obj,"\n");
              while(stt.hasMoreTokens()){
                try{
                  String stl = stt.nextToken();
                  stl=stl.trim();
                  if(stl.length()!=0){
                    StringTokenizer stt0 = new StringTokenizer(stl," =\t");
                    String st0 = stt0.nextToken();
                    if(st0.equalsIgnoreCase("TIME_SLEEP")){
                      doc.time_sleep = Integer.parseInt(stt0.nextToken());
                    }else if(st0.equalsIgnoreCase("WINDOW_BOUNDS")){
                        this.setBounds(Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()));
                    }else if(st0.equalsIgnoreCase("TIME_DEBUG")){
                      doc.time_debug = Integer.parseInt(stt0.nextToken());
                    }else if(st0.equalsIgnoreCase("NAME")){
                      doc.doc_name = stt0.nextToken("");
                      doc.doc_name = new String(doc.doc_name.substring(doc.doc_name.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                    }else if(st0.equalsIgnoreCase("AUTOR")){
                      doc.doc_autor = stt0.nextToken("");
                      doc.doc_autor = new String(doc.doc_autor.substring(doc.doc_autor.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                    }else if(st0.equalsIgnoreCase("INFO")){
                      doc.doc_info = stt0.nextToken("");
                      doc.doc_info = new String(doc.doc_info.substring(doc.doc_info.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                    }
                  }
                } catch(Exception e1) {error(e1);}
              }
            }
            st_obj=st;
          } else st_obj+="\n"+st;
        }
        if(st_obj!=null){
          StringTokenizer stt = new StringTokenizer(st_obj,"[] =\t");
          String st_Id = stt.nextToken();
          JMCADObject obj = (JMCADObject)Class.forName(stt.nextToken()).newInstance();
          obj.Id = st_Id;
          obj.parse(st_obj);
          doc.add(obj);
        }else if(st_obj!=null){
          StringTokenizer stt = new StringTokenizer(st_obj,"\n");
          while(stt.hasMoreTokens()){
            try{
              String stl = stt.nextToken();
              stl=stl.trim();
              if(stl.length()!=0){
                StringTokenizer stt0 = new StringTokenizer(stl," =\t");
                String st0 = stt0.nextToken();
                if(st0.equalsIgnoreCase("TIME_SLEEP")){
                  doc.time_sleep = Integer.parseInt(stt0.nextToken());
                }else if(st0.equalsIgnoreCase("WINDOW_BOUNDS")){
                  this.setBounds(Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()), Integer.parseInt(stt0.nextToken()));
                }else if(st0.equalsIgnoreCase("TIME_DEBUG")){
                      doc.time_debug = Integer.parseInt(stt0.nextToken());
                }else if(st0.equalsIgnoreCase("NAME")){
                  doc.doc_name = stt0.nextToken("");
                  doc.doc_name = new String(doc.doc_name.substring(doc.doc_name.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                }else if(st0.equalsIgnoreCase("AUTOR")){
                  doc.doc_autor = stt0.nextToken("");
                  doc.doc_autor = new String(doc.doc_autor.substring(doc.doc_autor.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                }else if(st0.equalsIgnoreCase("INFO")){
                  doc.doc_info = stt0.nextToken("");
                  doc.doc_info = new String(doc.doc_info.substring(doc.doc_info.indexOf("=")+1).trim().getBytes("ISO8859_1"),"Cp1251");
                }
              }
            } catch(Exception e1) {error(e1);}
          }
        }
        Component[] comp = doc.getComponents();
        JMCADObject[] obj = new JMCADObject[comp.length];
        for(int i=0; i<comp.length; i++) obj[i] = (JMCADObject)comp[i];
        for(int i=0; i<obj.length; i++){
          Object[] out_obj = obj[i].out_obj;
          for(int j=0; j<out_obj.length; j++){
            try{
              if(out_obj[j]!=null){
                JMCADObject obj_tmp=null;
                int obj_tmp_index=-1;
                StringTokenizer stt = new StringTokenizer(out_obj[j]+""," ");
                String st_id = stt.nextToken();
                String st_in = stt.nextToken();
                for(int k=0; k<obj.length; k++) if(obj[k].Id.toUpperCase().equals(st_id)) obj_tmp = obj[k];
                String[] in_text = obj_tmp.in_text;
                for(int k=0; k<in_text.length; k++){
                  if(in_text[k].equals(st_in)) obj_tmp_index = k;
                }
                obj[i].out_obj[j]=obj_tmp;
                obj[i].out_obj_index[j]=obj_tmp_index;
              }
            } catch(Exception e1) {error(e1);}
          }
        }
        doc.validate();
        this.setTitle(VERSION+" "+path+(doc.doc_name.length()>0?" - "+doc.doc_name:""));
    } catch(Exception e1) {error(e1);}
  }




}
